<?php
/**
 * Provides base class for AdminStatus plugins with appropriate default methods.
 */

namespace Drupal\admin_status\Plugin\AdminStatus;

use Drupal\admin_status\AdminStatusInterface;
use Drupal\Core\Plugin\PluginBase;
use Drupal\Core\Form\FormStateInterface;

class AdminStatusPluginBase extends PluginBase implements AdminStatusInterface {

  /**
   * Returns a markup description of the plugin.
   *
   * @return string
   *   A description of the plugin.
   */
  public function description() {
    return '';
  }

  /**
   * Builds a sub-form if needed to configure this plugin.
   *
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @param array $configValues
   *   An array of saved configuration values for this plugin.
   * @return array
   *   A form array with any configuration form elements needed to configure
   *   this plugin.
   */
  public function configForm(array $form,
                             FormStateInterface $form_state,
                             array $configValues) {
    return $form;
  }

  /**
   * Validates the plugin's configuration form values.
   *
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @param array $configValues
   *   An array of saved configuration values for this plugin.
   */
  public function configValidateForm(array $form,
                                     FormStateInterface $form_state,
                                     array $configValues) {
    return;
  }

  /**
   * Process submitted data and return configuration values to be saved.
   *
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @param array $configValues
   *   An array of saved configuration values for this plugin.
   * @return array
   *   An array of configuration values to be saved for this plugin.
   */
  public function configSubmitForm(array $form,
                                   FormStateInterface $form_state,
                                   array $configValues) {
    return array();
  }

  /**
   * Provides the status message to display to the user.
   *
   * @param array
   *   A form array with any configuration form elements needed to configure
   *   this plugin.
   * @return array
   *   An array, or an array with multiple subarrays, with the following keys:
   *   status - a legal drupal_set_message status value (status, warning, error)
   *   message - a string or a render array for the message
   */
  public function message(array $configValues) {
    return [];
  }

}
